/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, this 
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

3. The name of the author or contributors may not be used to endorse or promote 
products derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */

package be.cardon.sign;

import java.security.Permission;
import be.cardon.utils.Debug;
/**
 *
 * @author Rodolphe
 */
public class SignAppSecurityManager extends SecurityManager{
    
    private boolean allowExternalConnection=false;
    
    public SignAppSecurityManager(){
        super();
    }
            
    public void setAllowExternalConnection(boolean allowExtConn)
    throws SecurityException{
        this.allowExternalConnection = allowExtConn;
    }
    
     public void checkAccept(String host, int port)
     throws SecurityException, NullPointerException{
         Debug.println("SecManager: checkAccept host,port");
         //super.checkAccept(host, port);
     }
    
     public void checkAccess(Thread t)throws SecurityException{
         //Debug.println("secManager: checAccess tread");
         //super.checkAccess(t);
     }

    public void checkAccess(ThreadGroup g)throws SecurityException{
       //  Debug.println("secManager: checAccess tread");
         //super.checkAccess(g);
     }
    public  void checkConnect(String host, int port)throws SecurityException {
         Debug.println("checkConnect host:"+host +" port"+port);
         if(!allowExternalConnection){
            Debug.println("Throws exception...");
            throw new SecurityException("Access denied");
         }
         //super.checkConnect(host, port); 
     }
    public void checkConnect(String host, int port, Object context)throws SecurityException{
        Debug.println("checkConnect (context) host: "+host+",port:"+port+", conext");
        if(!allowExternalConnection){
            Debug.println("Throws exception...");
                 }
        //super.checkConnect(host, port, context);
    } 
     public void checkPermission(Permission perm) throws SecurityException{
       
        
        if(perm instanceof java.net.SocketPermission && !allowExternalConnection){
            Debug.println("Throws exception :"+perm.getName() + " & actions: "+perm.getActions());
            throw new SecurityException("Access denied");
        }
        //super.checkPermission(perm);
     }
    public void checkPermission(Permission perm, Object context){
         Debug.println("check perm,context");
         //super.checkPermission(perm, context);
    }
    
    
}


