/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, this 
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

3. The name of the author or contributors may not be used to endorse or promote 
products derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */


///////////////////////

// CURRENTLY NOT USED

//////////////////////




package be.cardon.sign.communicator;

import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import java.security.cert.Certificate;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.Provider;

import be.cardon.utils.Debug;
import be.cardon.utils.SimpleKeyStoreProvider;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManagerFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.HostnameVerifier;
import java.security.cert.CertificateFactory;


import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.security.NoSuchAlgorithmException;
import javax.net.ssl.HttpsURLConnection;
/**
 *
 * @author Rodolphe
 */
public class HTTPSUtils {
    
    /**
     * Creates a new instance of HTTPSUtils 
     */
    public HTTPSUtils() {
    }
    
    /** Download a URL with protocol https, check that the server certificate
     *matches the given certificate.
     *
     *  
     *@throws NoSuchAlgorithmException if cannot find an SSLContext implementation
     *
     */
    public static InputStream getSecureURL(URL address, Certificate serverCert)
    throws Exception{
        //create simple keystore in memory with the serverCert
        Provider ksProvider = new SimpleKeyStoreProvider();
        KeyStore ks = KeyStore.getInstance("SimpleKeyStore", ksProvider);
        ks.load(null, null);
        ks.setCertificateEntry("serverCert", serverCert);
        
        //create a TrustManager
        TrustManagerFactory tmf = TrustManagerFactory.getInstance(
                TrustManagerFactory.getDefaultAlgorithm());
        Debug.println("Trust Manager Factory = "+ tmf.getProvider());
        tmf.init(ks);
        
        //create an empty server name valider
        HostnameVerifier nothingVerifier = new HostnameVerifier(){
            public boolean verify(String hostname, javax.net.ssl.SSLSession session){
                Debug.println("hostname : " + hostname);
                Debug.println("peer host: " +session.getPeerHost());
                
                return true;
            }
        };
        
        //Configure SSL context
        SSLContext sslContext = SSLContext.getInstance("TLS");
        Debug.println("SSL context provider = " + sslContext.getProvider());
        sslContext.init(null, tmf.getTrustManagers(), null);
        
        //set this ssl context as default
        HttpsURLConnection.setDefaultSSLSocketFactory(sslContext.getSocketFactory());
        HttpsURLConnection.setDefaultHostnameVerifier(nothingVerifier);
         
        //open connection
        return address.openStream();
       
        
    }
    
    public static Certificate readCertificate(String PEMEncodedCert)
    throws Exception{
        
        byte[] der = org.bouncycastle.util.encoders.Base64.decode(PEMEncodedCert.getBytes());
        InputStream is = new ByteArrayInputStream(der);
        CertificateFactory cf = CertificateFactory.getInstance("X509");
        return cf.generateCertificate(is);
    }
    
}
