/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.
 
Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:
 
1. Redistributions of source code must retain the above copyright notice, this list
of conditions and the following disclaimer.
 
2. Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.
 
3. The name of the author or contributors may not be used to endorse or promote
products derived from this software without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
 */

package be.cardon.sign.communicator;

import be.cardon.utils.Debug;
import java.net.URL;
import java.net.URI;
import java.net.URLConnection;
import java.io.*;


/**
 *
 * @author crackapat
 */
public class SignatureUpload {
    
    /** Creates a new instance of SignatureUpload */
    public SignatureUpload() {
    }
    
    /**(return status 0) or throws exception, called by WebSignApplication.uploadSignature*/
    public static int uploadSignature(URI uploadURI, byte[] signature) throws Exception{
        if(signature==null){
            throw new NullPointerException("signature");
        }
        {
            BufferedReader reader  = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(signature)));
            String line;
            while((line=reader.readLine())!=null){
                Debug.println(line);
            }
            reader.close();
        }
        
        Debug.println("upload data ="+ signature);
        String signatureBase64 = "signature="+
                java.net.URLEncoder.encode(be.cardon.utils.Base64Utils.base64Encode(signature),"UTF-8");
        
        Debug.println("sig base 64: "+signatureBase64);
        
        URLConnection conn = uploadURI.toURL().openConnection();
        conn.setDoOutput(true);
        Debug.println("defaul timeout (ms): "+conn.getConnectTimeout());
        
        OutputStream os = conn.getOutputStream();
        os.write(signatureBase64.getBytes());
        os.close();
        BufferedReader reader = new BufferedReader(new InputStreamReader(conn.getInputStream()));
        String result = reader.readLine();
        Debug.println("result: "+result);
        
        String line;
        while((line=reader.readLine())!=null){
            Debug.println(line);
        }
        reader.close();
        
        if(result.equalsIgnoreCase("OK")){
            return 0;
        }
        throw new Exception("Server returns : "+result);
        
    }
}
