/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, this 
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

3. The name of the author or contributors may not be used to endorse or promote 
products derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */

package be.cardon.sign.shared;

import javax.swing.JTree;
import javax.swing.tree.*;
import javax.swing.event.*;
import be.cardon.sign.shared.FileHierarchyEntry.AbstractDirectory;
import be.cardon.utils.Debug;

/**
 *
 * @author Rodolphe
 */
public class FileHierarchyHandler implements TreeSelectionListener{
    
    private FileHierarchyTreeModel treeModel;
    private JTree tree;
    private FileHierarchyTableModel tableModel;
    
    /** Creates a new instance of FileHierarchyHandler */
    public FileHierarchyHandler(
            JTree fileHierarchyTree,
            FileHierarchyTableModel tableModel) throws FileHierarchyException{
        
        this.tree = fileHierarchyTree;
        this.tableModel = tableModel;
        //check fileHierarchy
        TreeModel treeModel = this.tree.getModel();
        if(treeModel  instanceof FileHierarchyTreeModel){
            this.treeModel = (FileHierarchyTreeModel)treeModel;
        }else{
            throw new FileHierarchyException("JTree must have a FileHierarchyTreeModel as model.");
        }
        this.tree.addTreeSelectionListener(this);
        
        this.tree.getSelectionModel().setSelectionMode
            (TreeSelectionModel.SINGLE_TREE_SELECTION);

        
    }
    
    /**
     * @inheritDoc
     */
    public void valueChanged(TreeSelectionEvent e){
         Object node = this.tree.getLastSelectedPathComponent();
         if (node == null) return;
         if(!(node instanceof AbstractDirectory)){
             Debug.println("node is not a AbstractDirectory:" +node.getClass().getCanonicalName());
             return;
         }
         AbstractDirectory abstrDir = (AbstractDirectory)node;
         this.tableModel.setAbstractDirectory(abstrDir);
    }

}