/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, this 
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

3. The name of the author or contributors may not be used to endorse or promote 
products derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */

package be.cardon.sign.shared;

import javax.swing.*;
import java.awt.*;
import java.net.URL;
/**Utilities
 *
 * @author Rodolphe
 */
public class GUIUtils {
    
    /**
     * Creates a new instance of Utils
     */
    public GUIUtils() {
    }
    
    public static JTextArea newTextAreaNote(Container parent, String text){
        JTextArea textArea = new JTextArea(text);
        textArea.setLineWrap(true);
        textArea.setFont(new JLabel().getFont()); // fix the 'windows' look and feel.
        textArea.setEditable(false);
        textArea.setBackground(parent.getBackground());
        return textArea;
    }
    
    public static void addBorder(JComponent comp){
        comp.setBorder(BorderFactory.createLineBorder(Color.BLACK));
    }
    
    public static Dimension infiniteDim= new Dimension(Short.MAX_VALUE, Short.MAX_VALUE);
    
    public static void setMaxSizeUnfinite(JComponent comp){
        comp.setMaximumSize(infiniteDim);
    }
    
    public static ImageIcon getImageIcon(String filename, String description){
        URL ressource = GUIUtils.class.getClassLoader().getResource(filename);
        if(ressource == null){
            System.err.println("GUIUtils getImage : resource not found:"+filename);
            return null;
        }
        return new ImageIcon(ressource, description);
    }
}
