/*
Copyright (c) 2006, CARDON DE LICHTBUER Rodolphe
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this list 
of conditions and the following disclaimer. 

2. Redistributions in binary form must reproduce the above copyright notice, this 
list of conditions and the following disclaimer in the documentation and/or 
other materials provided with the distribution. 

3. The name of the author or contributors may not be used to endorse or promote 
products derived from this software without specific prior written permission. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED 
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
DAMAGE.
 */

package be.cardon.sign.wizard;

import be.cardon.utils.Debug;
import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import be.cardon.sign.shared.DialogBox;
import javax.swing.border.*;


/** First panel with "hello" message
 *
 * @author Rodolphe
 */
public class WizardPanelHello extends WizardDefaultPanel{
    
    public static String cardName = "helloPanel";
    /** Creates a new instance of WizardPanelHello */
    
    public WizardPanelHello() {
        super(cardName);
        this.setTitle("Welcome");
        this.setDescription("Welcome in the WebSign wizard !");
        
        JPanel contentPanel = this.contentPanel;
        contentPanel.setLayout(new GridBagLayout());
        contentPanel.setBorder(BorderFactory.createEmptyBorder(5, 10, 5, 10));
        Dimension verticalLogoDim = new Dimension(155, 307);
        Icon verticalIcon = this.getImageIcon("images/websignVert.gif","logo");
        
        JLabel logoLabel = new JLabel();
        logoLabel.setIcon(verticalIcon);
        logoLabel.setPreferredSize(verticalLogoDim);
        logoLabel.setBorder(BorderFactory.createLoweredBevelBorder());
        
        JTextArea welcomeTextArea = new JTextArea();
        String version = this.getApplication().version;
        welcomeTextArea.setText("This wizard will help you to dowload, visualize," +
                " and sign documents with your private key.\n\nVersion: "+version);
        
        welcomeTextArea.setDisabledTextColor(Color.black);
        welcomeTextArea.setEnabled(false);
        welcomeTextArea.setBorder(BorderFactory.createEmptyBorder(20,20,20,20));
        welcomeTextArea.setFont(new JLabel().getFont());
        welcomeTextArea.setOpaque(false);
        welcomeTextArea.setLineWrap(true);
        welcomeTextArea.setWrapStyleWord(true);
        
        JTextArea licenseTextArea = new JTextArea();
        licenseTextArea.setLineWrap(true);
        licenseTextArea.setWrapStyleWord(true);
        licenseTextArea.setEditable(false);
        licenseTextArea.setText(this.getApplication().readLicense());
        
        JScrollPane licensePane = new JScrollPane(licenseTextArea);
        licensePane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        licensePane.getViewport().setPreferredSize(new Dimension(100,100));
        licensePane.setBorder(
                BorderFactory.createCompoundBorder(
                    BorderFactory.createEmptyBorder(0,20,0,20),
                    BorderFactory.createBevelBorder(BevelBorder.LOWERED)));
        
        GridBagConstraints c = new GridBagConstraints();

        c.anchor = c.CENTER;
        c.gridx=0;
        c.gridy=0;
        c.weightx = 0.4;
        c.gridheight = 2;
        contentPanel.add(logoLabel, c);

        c.gridx=1;
        c.gridy=0;
        c.weightx = 0.6;
        c.fill= c.BOTH;
        c.gridheight = 1;
        contentPanel.add(welcomeTextArea, c);

        c.gridx=1;
        c.gridy=1;
        c.gridheight = 1;
        //c.fill= c.BOTH;
        contentPanel.add(licensePane, c);

    }
    
    public void reinit(){
        previousButton.setEnabled(false);
    }
    
    public void actionPerformed(ActionEvent event){
        Object source = event.getSource();
        if(source.equals(cancelButton)){
            if(this.showDefaultQuitDialog()){
                getApplication().quit();
                return;
            }
        }
        if(source.equals(helpButton)){
            Debug.println("clic on help button.");
        }
        if(source.equals(previousButton)){
            Debug.println("clic on previous button.");
        }
        if(source.equals(nextButton)){
            //check appletParameter
            try{
                this.getApplication().makeDownloaderFileList();
            }catch(Exception e){
                DialogBox.showExceptionBox(
                        this.wizardFrame,
                        "Invalid arguments given at the applet",
                        e);
                return;
            }
            this.wizardFrame.setCurrentPanel(WizardPanelTargetDir.cardName);
            return;

        }
    }
}
