
/*
 * Copyright  1999-2004 The Apache Software Foundation.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package be.cardon.sign.xmldsig.dereferencer;



import com.sun.org.apache.xml.internal.security.exceptions.XMLSecurityException;
import be.cardon.utils.Debug;
import javax.xml.crypto.URIReference;
import org.w3c.dom.Document;


/**
 * This Exception is thrown if something related to the
 * {@link org.apache.xml.security.utils.resolver.ResourceResolver} goes wrong.
 *
 * @author $Author: raul $
 */
public class ResourceResolverException extends XMLSecurityException {

   /**
	 * 
	 */
	private static final long serialVersionUID = 1L;
        private URIReference _uriRef; 
   /**
    * Constructor ResourceResolverException
    *
    * @param _msgID
    * @param uri
    * @param BaseURI
    */
   public ResourceResolverException(String _msgID, URIReference uriRef, String BaseURI) {

      super(_msgID);

      this._uriRef = uriRef;
      this._BaseURI = BaseURI;
   }

   /**
    * Constructor ResourceResolverException
    *
    * @param _msgID
    * @param exArgs
    * @param uri
    * @param BaseURI
    */
   public ResourceResolverException(String _msgID, Object exArgs[], URIReference uriRef,
                                    String BaseURI) {

      super(_msgID, exArgs);

      this._uriRef = uriRef;
      this._BaseURI = BaseURI;
   }

   /**
    * Constructor ResourceResolverException
    *
    * @param _msgID
    * @param _originalException
    * @param uri
    * @param BaseURI
    */
   public ResourceResolverException(String _msgID, Exception _originalException,
                                    URIReference uriRef, String BaseURI) {

      super(_msgID, _originalException);

      this._uriRef = uriRef;
      this._BaseURI = BaseURI;
   }

   /**
    * Constructor ResourceResolverException
    *
    * @param _msgID
    * @param exArgs
    * @param _originalException
    * @param uri
    * @param BaseURI
    */
   public ResourceResolverException(String _msgID, Object exArgs[],
                                    Exception _originalException, URIReference uriRef,
                                    String BaseURI) {

      super(_msgID, exArgs, _originalException);

      this._uriRef = uriRef;
      this._BaseURI = BaseURI;
   }


   /**
    * 
    * @param uri
    */
   public void setURIReference(URIReference uriRef) {
      this._uriRef = uriRef;
   }
   
   /**
    * 
    * @return the uri
    */
   public URIReference getURIReference() {
      return this._uriRef;
   }

   String _BaseURI;
   
   /**
    * 
    * @param BaseURI
    */
   public void setBaseURI(String BaseURI) {
      this._BaseURI = BaseURI;
   }
   
   /**
    * 
    * @return the basUri
    */
   public String getBaseURI() {
      return this._BaseURI;
   }
   //J+
}
