





// inutilisatble => NodeSetData pas encore implment !!










/*
 * Copyright  1999-2004 The Apache Software Foundation.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package be.cardon.sign.xmldsig.dereferencer.implementations;


import com.sun.org.apache.xml.internal.security.signature.XMLSignatureInput;
import com.sun.org.apache.xml.internal.security.utils.IdResolver;
import be.cardon.sign.xmldsig.dereferencer.ResourceResolverException;
import be.cardon.sign.xmldsig.dereferencer.ResourceResolverSpi;
import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import javax.xml.crypto.URIReference;
import be.cardon.utils.Debug;

/**
 * This resolver is used for resolving same-document URIs like URI="" of URI="#id".
 *
 * @author $Author: dims $
 * @see <A HREF="http://www.w3.org/TR/xmldsig-core/#sec-ReferenceProcessingModel">The Reference processing model in the XML Signature spec</A>
 * @see <A HREF="http://www.w3.org/TR/xmldsig-core/#sec-Same-Document">Same-Document URI-References in the XML Signature spec</A>
 * @see <A HREF="http://www.ietf.org/rfc/rfc2396.txt">Section 4.2 of RFC 2396</A>
 */
public class ResolverFragment extends ResourceResolverSpi {


   /**
    * Method engineResolve
    *
    * Wird das gleiche Dokument referenziert?
    * Wird ein anderes Dokument referenziert?
    * @inheritDoc
    * @param uri
    * @param BaseURI
    *
    */
   public XMLSignatureInput engineResolve(URIReference uriRef, String BaseURI, Document sigDoc) 
       throws ResourceResolverException
   {

      String uriNodeValue = uriRef.getURI();
      Document doc = sigDoc;

      be.cardon.utils.XMLUtils.dumpDocument(doc);
      Node selectedElem = null;
      if (uriNodeValue.equals("")) {

         /*
          * Identifies the node-set (minus any comment nodes) of the XML
          * resource containing the signature
          */

         Debug.println("ResolverFragment with empty URI (means complete document)");
	 selectedElem = doc;
      } else {

         /*
          * URI="#chapter1"
          * Identifies a node-set containing the element with ID attribute
          * value 'chapter1' of the XML resource containing the signature.
          * XML Signature (and its applications) modify this node-set to
          * include the element plus all descendents including namespaces and
          * attributes -- but not comments.
          */
         String id = uriNodeValue.substring(1);

         // Element selectedElem = doc.getElementById(id);
         Debug.println("id="+id);
         if(doc==null){
            Debug.println("doc null");
         }else{
             Debug.println("doc="+IdResolver.getElementById(doc, id).toString());
         }
         
         selectedElem = IdResolver.getElementById(doc, id);
         if (selectedElem==null) {
         	Object exArgs[] = { id };
            throw new ResourceResolverException(
               "signature.Verification.MissingID", exArgs, uriRef, BaseURI);
         }
         Debug.println("Try to catch an Element with ID " + id + " and Element was " + selectedElem);
      }
      XMLSignatureInput result = new XMLSignatureInput(selectedElem);

      result.setExcludeComments(true);

      //log.debug("We return a nodeset with " + resultSet.size() + " nodes");
      result.setMIMEType("text/xml");	  
      result.setSourceURI((BaseURI != null) ? BaseURI.concat(uriRef.getURI()) :
		  uriRef.getURI());      
      return result;
   }

   /**
    * Method engineCanResolve
    * @inheritDoc
    * @param uri
    * @param BaseURI
    *
    */
   public boolean engineCanResolve(URIReference uriRef, String BaseURI, Document sigDoc) {

      if (uriRef.getURI() == null) {
         Debug.println("Quick fail for null uri");
         return false;
      }

      String uriNodeValue = uriRef.getURI();

      if (uriNodeValue.equals("")
              || ((uriNodeValue.charAt(0)=='#')
                  &&!uriNodeValue.startsWith("#xpointer("))) {
         Debug.println("State I can resolve reference: \"" + uriNodeValue + "\"");
         return true;
      }
      Debug.println("Do not seem to be able to resolve reference: \"" + uriNodeValue + "\"");
      return false;
   }

}
