



// by Cardon :
// fixed UNICODE encoding using the java.net.URI class.




/*
 * Copyright  1999-2004 The Apache Software Foundation.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package be.cardon.sign.xmldsig.dereferencer.implementations;



import java.io.FileInputStream;

import java.net.URI;
import com.sun.org.apache.xml.internal.security.signature.XMLSignatureInput;
import be.cardon.sign.xmldsig.dereferencer.ResourceResolverException;
import be.cardon.sign.xmldsig.dereferencer.ResourceResolverSpi;
import org.w3c.dom.Attr;
import be.cardon.utils.Debug;
import javax.xml.crypto.URIReference;
import org.w3c.dom.Document;


/**
 * A simple ResourceResolver for requests into the local filesystem.
 *
 * @author $Author: raul $
 */
public class ResolverLocalFilesystem extends ResourceResolverSpi {

   
   /**
    * @inheritDoc
    */
   public XMLSignatureInput engineResolve(URIReference uriRef, String BaseURIString, Document sigDoc)
           throws ResourceResolverException {
     
     try {
        
        URI BaseURI = new URI(BaseURIString);
        URI ResolvedURI = BaseURI.resolve(uriRef.getURI());
        
        String path = ResolvedURI.getPath(); //decoded Path
        FileInputStream inputStream = new FileInputStream(path);
        XMLSignatureInput result = new XMLSignatureInput(inputStream);

        result.setSourceURI(ResolvedURI.toString());

        return result;
     } catch (Exception e) {
        throw new ResourceResolverException("generic.EmptyMessage", e, uriRef,
                                            BaseURIString);
      }
   }


   /**
    * @inheritDoc
    */
   public boolean engineCanResolve(URIReference uriRef, String BaseURI, Document docSig) {

      if (uriRef == null) {
         return false;
      }
      if (uriRef.getURI() == null) {
         return false;
      }

      String uriNodeValue = uriRef.getURI();

      if (uriNodeValue.equals("") || (uriNodeValue.charAt(0)=='#')) {
         return false;
      }

      try {
	         //URI uriNew = new URI(new URI(BaseURI), uri.getNodeValue());
	         Debug.println("I was asked whether I can resolve " + uriNodeValue/*uriNew.toString()*/);

	         if ( uriNodeValue.startsWith("file:") ||
					 BaseURI.startsWith("file:")/*uriNew.getScheme().equals("file")*/) {
	            Debug.println("I state that I can resolve " + uriNodeValue/*uriNew.toString()*/);

	            return true;
	         }
      } catch (Exception e) {}

      Debug.println("But I can't");

      return false;
   }
}
